// FILENAME:	HUNT_Cold_Titan_Night.cs
//
// AUTHOR:  	dun_Starscaper
//------------------------------------------------------------------------------

$missionName = "HUNT_Cold_Titan_Night";

$healRate = 100;
$ammoRate = 3;
$padWaitTime = 45;
$zenWaitTime = 90;

$GreedEnabled = false;      //Whether game run under greed mode
$HoardEnabled = false;      //Whether game run under hoard mode

exec("multiplayerStdLib.cs");
exec("HunterStdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;
}

function onMissionLoad()
{
	titanSounds();	
	cdAudioCycle("SS3", "SS4", "Watching"); 
}

//Special nexus functionality -- beam goes blue/red instead of appearing/disappearing
function setNexus(%status)
{
  playAnimSequence(getObjectID("MissionGroup\\Nexus\\NexusBeam"), 0, %status);
  playAnimSequence(getObjectID("MissionGroup\\Nexus\\badBeam"),   0, %status);
  $NexusOnline = %status;
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}

//If someone shoots frosty, his houses blow up revealing a nasty surprise
//------------------------------------------------
function tur1::turret::onAdd(%this)
{
	$turret1=%this;
	order($turret1,ShutDown,true);
}
function tur2::turret::onAdd(%this)
{
	$turret2=%this;
	order($turret2,ShutDown,true);
}
function Frosty::structure::onAttacked(%attacked,%attacker)
{
	%bang1=getObjectId("MissionGroup\\extra\\frosty's house\\house1");
	healObject(%bang1,-30000);
	order($turret1,ShutDown,false);
	order($turret1, Attack, %attacker);
	%bang2=getObjectId("MissionGroup\\extra\\frosty's house\\house2");
	healObject(%bang2,-30000);
	order($turret2,ShutDown,false);
	order($turret2, Attack, %attacker);
}
