// FILENAME:	HUNT_Heavens_Peak.cs
//
// AUTHOR:  	dun_Starscaper
//------------------------------------------------------------------------------

$missionName = "HUNT_Heavens_Peak";

$healRate = 100;            //Amount of healing per pad tick
$ammoRate = 3;              //Amount of reloading per pad tick
$padWaitTime = 45;          //Heal or Ammo Pad recharge time, in seconds
$zenWaitTime = 90;          //Zen Pad recharge time, in seconds

$GreedEnabled = false;      //Whether game run under greed mode
$HoardEnabled = false;      //Whether game run under hoard mode

exec("multiplayerStdLib.cs");
exec("HunterStdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay        = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay   = true;	
	
	$server::AllowTeamRed    = true;
	$server::AllowTeamBlue   = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;
}

function onMissionLoad()
{
  cdAudioCycle("Purge", "Newtech", "Cyberntx"); 
	temperateSounds();
}

// move the map
$server::HudMapViewOffsetX = -1500;
$server::HudMapViewOffsetY = 2500;

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}