// FILENAME:	HUNT_Requiem_for_General_Lanz.cs
//
// AUTHOR:  	dun_Starscaper
//------------------------------------------------------------------------------

$missionName = "HUNT_Requiem_for_Gen_Lanz";

$GreedEnabled = false;      //Whether game run under greed mode
$HoardEnabled = true;       //Whether game run under hoard mode

exec("multiplayerStdLib.cs");
exec("HunterStdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;
}

function onMissionLoad(){
	$blastRadius = 100;   // for ammo boxes
	$blastDamage = 4000;   

	iceSounds();	
  cdAudioCycle("Purge", "Newtech", "SS4", "SS3"); 

  // custom rules for this mission ( teleporter )
  %rules = "<F2>GameType\n<F0>";
  if($server::TeamPlay)
    %rules = %rules @ "Team ";
  %rules = %rules @ "Hunter\n\n"
                  @ "<F2>Mission\n<F0>" @ $missionName @ "\n\n"
                  @ "<F2>Synopsis\n<F0>Collect flags from your enemies and return them for points.\n\n"
                  @ "<F2>Rules\n<F0>Every time a player dies, he/she/<<it> leaves a flag. Another player can collect the "
                  @ "flag by running over it. Dead players also drop all flags they are carrying at time of death.\n\n"
                  @ "Players can redeem flags for points by running through the <F3>Nexus<F0> at Nav Alpha.\n\n";
  if($server::TeamPlay)
    %rules = %rules @ "They can also pass flags to their teammates by scanning them.\n\n";
  if($GreedEnabled)
    %rules = %rules @ "<F3>Greed<F0> mode is enabled. Players cannot score until they have at least <F3>" @ $GreedAmt
                    @ "<F0> flags.\n\n";
  if(($HoardEnabled)&&(isTimeLimit()))
    %rules = %rules @ "<F3>Hoard<F0> mode is enabled. There will be a period <F3>" @ timeDifference($HoardStart, $HoardEnd)
                    @ "<F0> long towards the end of the match when nobody can score.\n\n";
  %rules = %rules @ "<F2>Scoring\n<F0>Players get <F3>" @ $KillPts @ "<F0> points for killing another player.\n\n"
                  @ "When flags are returned to the Nexus, their value increases with the number of flags the player is carrying. "
                  @ "For example, 2 flags are worth <F3>" @ flagsToPoints(2) @ "<F0> points, but 4 flags are worth <F3>"
                  @ flagsToPoints(4) @ "<F0> points.\n\n";
  if($server::TeamPlay)
    %rules = %rules @ "The team's score is the sum of its members' scores.\n\n";
  
  %rules = %rules @ "<tIDMULT_STD_ITEMS>"    @
                    "<bctf1.bmp><F3>Flags:<F0> Collect flags by running over them.\n\n\n\n\n\n\n" @
                    "<btele1.bmp><F3>Nexus:<F0> Run through it while carrying flags to score points.\n\n\n\n\n\n" @
                    "<tIDMULT_STD_TELEPORTER>" @
                    "<tIDMULT_STD_HEAL>"     @
                    "<tIDMULT_STD_RELOAD_1>" @ $PadWaitTime @ "<tIDMULT_STD_RELOAD_2>"   @
                    "<tIDMULT_STD_ZEN_1>"    @ $ZenWaitTime @ "<tIDMULT_STD_ZEN_2>";

   setGameInfo(%rules);
}

function turret::onAdd(%this)
{
	if($server::TeamPlay == false)
		setTeam(%this, *IDSTR_TEAM_NEUTRAL);
}

function Ammo::structure::onDestroyed(%destroyee, %destroyer)
{
  echo("KABOOM!");
  damageArea(%destroyee, 0, 0, 0, $blastRadius, $blastDamage);
}

// Transporter Functionality
// --------------------------------------------------------------------------
function deathmatchTransport(%this, %vehicleId)
{
	%teamName = getTeam(%vehicleId);
   
	%huh = randomInt(1, 5);
	if(%huh == 1)
		transportToYellowBase(%vehicleId);
	else if(%huh == 2)
		transportToBlueBase(%vehicleId);
	else if(%huh == 3)
		transportToRedBase(%vehicleId);
	else if(%huh == 4)
		transportToPurpleBase(%vehicleId);
	else
		transportToMountain(%vehicleId);
}

function YellowTransporter::trigger::onEnter(%this, %vehicleId)
{
	if($server::TeamPlay == false)
	{
		deathmatchTransport(%this, %vehicleId);
		return;
	}

	%teamName = getTeam(%vehicleId);
   
 	if(%teamName == *IDSTR_TEAM_YELLOW)
 	{
		%huh = randomInt(1, 4);
		if(%huh == 1)
			transportToBlueBase(%vehicleId);
		else if(%huh == 2)
			transportToRedBase(%vehicleId);
		else if(%huh == 3)
			transportToPurpleBase(%vehicleId);
		else
			transportToMountain(%vehicleId);
	}
	else
		transportToHomeBase(%vehicleId);
}

function BlueTransporter::trigger::onEnter(%this, %vehicleId)
{
	if($server::TeamPlay == false)
	{
		deathmatchTransport(%this, %vehicleId);
		return;
	}

	%teamName = getTeam(%vehicleId);
   
 	if(%teamName == *IDSTR_TEAM_BLUE)
 	{
		%huh = randomInt(1, 4);
		if(%huh == 1)
			transportToYellowBase(%vehicleId);
		else if(%huh == 2)
			transportToRedBase(%vehicleId);
		else if(%huh == 3)
			transportToPurpleBase(%vehicleId);
		else
			transportToMountain(%vehicleId);
	}
	else
		transportToHomeBase(%vehicleId);
}
function RedTransporter::trigger::onEnter(%this, %vehicleId)
{
	if($server::TeamPlay == false)
	{
		deathmatchTransport(%this, %vehicleId);
		return;
	}
	%teamName = getTeam(%vehicleId);
   
  if(%teamName == *IDSTR_TEAM_RED)
  {
		%huh = randomInt(1, 4);
		if(%huh == 1)
			transportToBlueBase(%vehicleId);
		else if(%huh == 2)
			transportToYellowBase(%vehicleId);
		else if(%huh == 3)
			transportToPurpleBase(%vehicleId);
		else
			transportToMountain(%vehicleId);
	}
	else
		transportToHomeBase(%vehicleId);
}

function PurpleTransporter::trigger::onEnter(%this, %vehicleId)
{
	if($server::TeamPlay == false)
	{
		deathmatchTransport(%this, %vehicleId);
		return;
	}
	%teamName = getTeam(%vehicleId);

 	if(%teamName == *IDSTR_TEAM_PURPLE)
 	{
		%huh = randomInt(1, 4);
		if(%huh == 1)
			transportToBlueBase(%vehicleId);
		else if(%huh == 2)
			transportToRedBase(%vehicleId);
		else if(%huh == 3)
			transportToYellowBase(%vehicleId);
		else
			transportToMountain(%vehicleId);
	}
	else
		transportToHomeBase(%vehicleId);
}

function transportToBlueBase(%vehicleId)
{
	echo("Transporting to Blue Base");
	randomTransport(%vehicleId, 2151, 1078, 2185, 802);
}
function transportToYellowBase(%vehicleId)
{
	echo("Transporting to Yellow Base");
	randomTransport(%vehicleId, 582, -2016, 715, -1968);
}
function transportToRedBase(%vehicleId)
{
	echo("Transporting to Red Base");
	randomTransport(%vehicleId, 669, 3201, 746, 3046);
}
function transportToPurpleBase(%vehicleId)
{
	echo("Transporting to Purple Base");
  randomTransport(%vehicleId, -2948, 66, -3041, -117);
}
function transportToMountain(%vehicleId)
{
  randomTransport(%vehicleId, 56, 667, 60, 675);
}

function transportToHomeBase(%vehicleId)
{
	// What colour is this person?
   %teamName = getTeam(%vehicleId);
   
	// Call the appropriate transport function (above) and get them home
   if(%teamName == *IDSTR_TEAM_YELLOW)
      transportToYellowBase(%vehicleId);
   else if(%teamName == *IDSTR_TEAM_RED)
      transportToRedBase(%vehicleId);
   else if(%teamName == *IDSTR_TEAM_BLUE)
      transportToBlueBase(%vehicleId);
   else if(%teamName == *IDSTR_TEAM_PURPLE)
      transportToPurpleBase(%vehicleId);
   else
      deathmatchTransport(%vehicleID);
}

// The following code is necessary for everything on the mountain
// ------------------------------------------------------------------------------

function ZenTransporter::trigger::onContact(%this, %object)
{
	Zen::work(%this, %object, 100000, 100, 0, false);
	setPosition(%object, -183, 573, 1500);
}

function ball1::structure::onAttacked(%this, %attacker)
{
	transportToYellowBase(%attacker);
}
function ball2::structure::onAttacked(%this, %attacker)
{
	transportToBlueBase(%attacker);
}
function ball3::structure::onAttacked(%this, %attacker)
{
	transportToRedBase(%attacker);
}
function ball4::structure::onAttacked(%this, %attacker)
{
	transportToPurpleBase(%attacker);
}